Hamlet.Q (Apache Hadoop YARN Common 3.5.0 API)
Description: declaration: package: org.apache.hadoop.yarn.webapp.hamlet2, class: Hamlet, class: Q

Package org.apache.hadoop.yarn.webapp.hamlet2

# Class Hamlet.Q<T extends HamletSpec.__>

java.lang.Object
org.apache.hadoop.yarn.webapp.hamlet2.HamletImpl.EImp<T>
org.apache.hadoop.yarn.webapp.hamlet2.Hamlet.Q<T>

All Implemented Interfaces:
  `HamletSpec.__`, `HamletSpec._Anchor`, `HamletSpec._Child`, `HamletSpec._Content`, `HamletSpec._FontSize`, `HamletSpec._FontStyle`, `HamletSpec._FormCtrl`, `HamletSpec._ImgObject`, `HamletSpec._InsDel`, `HamletSpec._Label`, `HamletSpec._Object`, `HamletSpec._RawContent`, `HamletSpec._Script`, `HamletSpec._Special`, `HamletSpec._SubSup`, `HamletSpec.Attrs`, `HamletSpec.CoreAttrs`, `HamletSpec.EventsAttrs`, `HamletSpec.FontStyle`, `HamletSpec.FormCtrl`, `HamletSpec.I18nAttrs`, `HamletSpec.Inline`, `HamletSpec.PCData`, `HamletSpec.Phrase`, `HamletSpec.Q`, `HamletSpec.Special`

Enclosing class:
  Hamlet

public class Hamlet.Q<T extends HamletSpec.__> extends HamletImpl.EImp<T> implements HamletSpec.Q

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `Q(String name, T parent, EnumSet<HamletImpl.EOpt> opts)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Hamlet.Q<T>`
  `__(Object... lines)`
  Content of the element
  `Hamlet.Q<T>`
  `_r(Object... lines)`
  Raw (no need to be HTML escaped) content
  `Hamlet.Q<T>`
  `$cite(String value)`
  URI for source document or msg
  `Hamlet.Q<T>`
  `$class(String value)`
  space-separated list of classes
  `Hamlet.Q<T>`
  `$dir(HamletSpec.Dir value)`
  direction for weak/neutral text
  `Hamlet.Q<T>`
  `$id(String value)`
  document-wide unique id
  `Hamlet.Q<T>`
  `$lang(String value)`
  language code
  `Hamlet.Q<T>`
  `$onclick(String value)`
  a pointer button was clicked
  `Hamlet.Q<T>`
  `$ondblclick(String value)`
  a pointer button was double clicked
  `Hamlet.Q<T>`
  `$onkeydown(String value)`
  a key was pressed down
  `Hamlet.Q<T>`
  `$onkeypress(String value)`
  a key was pressed and released
  `Hamlet.Q<T>`
  `$onkeyup(String value)`
  a key was released
  `Hamlet.Q<T>`
  `$onmousedown(String value)`
  a pointer button was pressed down
  `Hamlet.Q<T>`
  `$onmousemove(String value)`
  a pointer was moved within
  `Hamlet.Q<T>`
  `$onmouseout(String value)`
  a pointer was moved away
  `Hamlet.Q<T>`
  `$onmouseover(String value)`
  a pointer was moved onto
  `Hamlet.Q<T>`
  `$onmouseup(String value)`
  a pointer button was released
  `Hamlet.Q<T>`
  `$style(String value)`
  associated style info
  `Hamlet.Q<T>`
  `$title(String value)`
  advisory title
  `Hamlet.A<Hamlet.Q<T>>`
  `a()`
  Add a A (anchor) element.
  `Hamlet.A<Hamlet.Q<T>>`
  `a(String selector)`
  Add a A (anchor) element.
  `Hamlet.Q<T>`
  `a(String href, String anchorText)`
  Shortcut for `a().`
  `Hamlet.Q<T>`
  `a(String selector, String href, String anchorText)`
  Shortcut for `a(selector).`
  `Hamlet.ABBR<Hamlet.Q<T>>`
  `abbr()`
  Add an ABBR (abbreviation) element.
  `Hamlet.Q<T>`
  `abbr(String cdata)`
  Add a ABBR (abbreviation) element.
  `Hamlet.Q<T>`
  `abbr(String selector, String cdata)`
  Add a ABBR (abbreviation) element.
  `Hamlet.B<Hamlet.Q<T>>`
  `b()`
  Add a new B (bold/important) element.
  `Hamlet.Q<T>`
  `b(String cdata)`
  Add a complete B (bold/important) element.
  `Hamlet.Q<T>`
  `b(String selector, String cdata)`
  Add a complete B (bold/important) element.
  `Hamlet.BDO<Hamlet.Q<T>>`
  `bdo()`
  Add a bdo (bidirectional override) element
  `Hamlet.Q<T>`
  `bdo(HamletSpec.Dir dir, String cdata)`
  Add a bdo (bidirectional override) element
  `Hamlet.BR<Hamlet.Q<T>>`
  `br()`
  Add a BR (line break) element.
  `Hamlet.Q<T>`
  `br(String selector)`
  Add a BR (line break) element.
  `Hamlet.BUTTON<Hamlet.Q<T>>`
  `button()`
  Add a BUTTON element.
  `Hamlet.BUTTON<Hamlet.Q<T>>`
  `button(String selector)`
  Add a BUTTON element.
  `Hamlet.Q<T>`
  `button(String selector, String cdata)`
  Add a complete BUTTON element.
  `Hamlet.CITE<Hamlet.Q<T>>`
  `cite()`
  Add a CITE element.
  `Hamlet.Q<T>`
  `cite(String cdata)`
  Add a CITE element.
  `Hamlet.Q<T>`
  `cite(String selector, String cdata)`
  Add a CITE element.
  `Hamlet.CODE<Hamlet.Q<T>>`
  `code()`
  Add a CODE (code fragment) element.
  `Hamlet.Q<T>`
  `code(String cdata)`
  Add a complete CODE element.
  `Hamlet.Q<T>`
  `code(String selector, String cdata)`
  Add a complete CODE element.
  `Hamlet.DEL<Hamlet.Q<T>>`
  `del()`
  Add a DEL (delete) element.
  `Hamlet.Q<T>`
  `del(String cdata)`
  Add a complete DEL element.
  `Hamlet.DFN<Hamlet.Q<T>>`
  `dfn()`
  Add a DFN element.
  `Hamlet.Q<T>`
  `dfn(String cdata)`
  Add a complete DFN element.
  `Hamlet.Q<T>`
  `dfn(String selector, String cdata)`
  Add a complete DFN element.
  `Hamlet.EM<Hamlet.Q<T>>`
  `em()`
  Add an EM (emphasized) element.
  `Hamlet.Q<T>`
  `em(String cdata)`
  Add an EM (emphasized) element.
  `Hamlet.Q<T>`
  `em(String selector, String cdata)`
  Add an EM (emphasized) element.
  `Hamlet.I<Hamlet.Q<T>>`
  `i()`
  Add an I (italic, alt voice/mood) element.
  `Hamlet.Q<T>`
  `i(String cdata)`
  Add a complete I (italic, alt voice/mood) element.
  `Hamlet.Q<T>`
  `i(String selector, String cdata)`
  Add a complete I (italic, alt voice/mood) element.
  `Hamlet.IMG<Hamlet.Q<T>>`
  `img()`
  Add a IMG (image) element.
  `Hamlet.Q<T>`
  `img(String src)`
  Add a IMG (image) element.
  `Hamlet.INPUT<Hamlet.Q<T>>`
  `input()`
  Add a INPUT element.
  `Hamlet.INPUT<Hamlet.Q<T>>`
  `input(String selector)`
  Add a INPUT element.
  `Hamlet.INS<Hamlet.Q<T>>`
  `ins()`
  Add an INS (insert) element.
  `Hamlet.Q<T>`
  `ins(String cdata)`
  Add a complete INS element.
  `Hamlet.KBD<Hamlet.Q<T>>`
  `kbd()`
  Add a KBD (keyboard) element.
  `Hamlet.Q<T>`
  `kbd(String cdata)`
  Add a KBD (keyboard) element.
  `Hamlet.Q<T>`
  `kbd(String selector, String cdata)`
  Add a KBD (keyboard) element.
  `Hamlet.LABEL<Hamlet.Q<T>>`
  `label()`
  Add a LABEL element.
  `Hamlet.Q<T>`
  `label(String forId, String cdata)`
  Add a LABEL element.
  `Hamlet.MAP<Hamlet.Q<T>>`
  `map()`
  Add a MAP element.
  `Hamlet.MAP<Hamlet.Q<T>>`
  `map(String selector)`
  Add a MAP element.
  `Hamlet.OBJECT<Hamlet.Q<T>>`
  `object()`
  Add an object element.
  `Hamlet.OBJECT<Hamlet.Q<T>>`
  `object(String selector)`
  Add an object element.
  `Hamlet.Q<Hamlet.Q<T>>`
  `q()`
  Add a Q (inline quotation) element.
  `Hamlet.Q<T>`
  `q(String cdata)`
  Add a complete Q element.
  `Hamlet.Q<T>`
  `q(String selector, String cdata)`
  Add a Q element.
  `Hamlet.SAMP<Hamlet.Q<T>>`
  `samp()`
  Add a SAMP (sample) element.
  `Hamlet.Q<T>`
  `samp(String cdata)`
  Add a complete SAMP (sample) element.
  `Hamlet.Q<T>`
  `samp(String selector, String cdata)`
  Add a complete SAMP (sample) element.
  `Hamlet.SCRIPT<Hamlet.Q<T>>`
  `script()`
  Add a script element.
  `Hamlet.Q<T>`
  `script(String src)`
  Add a script element
  `Hamlet.SELECT<Hamlet.Q<T>>`
  `select()`
  Add a SELECT element.
  `Hamlet.SELECT<Hamlet.Q<T>>`
  `select(String selector)`
  Add a SELECT element.
  `Hamlet.SMALL<Hamlet.Q<T>>`
  `small()`
  Add a SMALL (small print) element
  `Hamlet.Q<T>`
  `small(String cdata)`
  Add a complete small (small print) element.
  `Hamlet.Q<T>`
  `small(String selector, String cdata)`
  Add a complete small (small print) element.
  `Hamlet.SPAN<Hamlet.Q<T>>`
  `span()`
  Add a SPAN element.
  `Hamlet.Q<T>`
  `span(String cdata)`
  Add a SPAN element.
  `Hamlet.Q<T>`
  `span(String selector, String cdata)`
  Add a SPAN element.
  `Hamlet.STRONG<Hamlet.Q<T>>`
  `strong()`
  Add a STRONG (important) element.
  `Hamlet.Q<T>`
  `strong(String cdata)`
  Add a complete STRONG (important) element.
  `Hamlet.Q<T>`
  `strong(String selector, String cdata)`
  Add a complete STRONG (important) element.
  `Hamlet.SUB<Hamlet.Q<T>>`
  `sub()`
  Add a SUB (subscript) element.
  `Hamlet.Q<T>`
  `sub(String cdata)`
  Add a complete SUB (subscript) element.
  `Hamlet.Q<T>`
  `sub(String selector, String cdata)`
  Add a complete SUB (subscript) element.
  `Hamlet.SUP<Hamlet.Q<T>>`
  `sup()`
  Add a SUP (superscript) element.
  `Hamlet.Q<T>`
  `sup(String cdata)`
  Add a SUP (superscript) element.
  `Hamlet.Q<T>`
  `sup(String selector, String cdata)`
  Add a SUP (superscript) element.
  `Hamlet.TEXTAREA<Hamlet.Q<T>>`
  `textarea()`
  Add a TEXTAREA element.
  `Hamlet.TEXTAREA<Hamlet.Q<T>>`
  `textarea(String selector)`
  Add a TEXTAREA element.
  `Hamlet.Q<T>`
  `textarea(String selector, String cdata)`
  Add a complete TEXTAREA element.
  `Hamlet.VAR<Hamlet.Q<T>>`
  `var()`
  Add a VAR (variable) element.
  `Hamlet.Q<T>`
  `var(String cdata)`
  Add a VAR (variable) element.
  `Hamlet.Q<T>`
  `var(String selector, String cdata)`
  Add a VAR (variable) element.

  ### Methods inherited from class org.apache.hadoop.yarn.webapp.hamlet2.HamletImpl.EImp

  `__, _endTag, _inline, _p, _pre, _v, addAttr, addAttr, addMediaAttr, addRelAttr, closeAttrs`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

  ### Methods inherited from interface org.apache.hadoop.yarn.webapp.hamlet2.HamletSpec._Child

  `__`

- ## Constructor Details

  - ### Q

    public Q(String name, T parent, EnumSet<HamletImpl.EOpt> opts)

- ## Method Details

  - ### $cite

    public Hamlet.Q<T> $cite(String value)
    Description copied from interface: `HamletSpec.Q`
    URI for source document or msg
    Specified by:
      `$cite` in interface `HamletSpec.Q`
    Parameters:
      `value` - the URI
    Returns:
      the current element builder

  - ### $id

    public Hamlet.Q<T> $id(String value)
    Description copied from interface: `HamletSpec.CoreAttrs`
    document-wide unique id
    Specified by:
      `$id` in interface `HamletSpec.CoreAttrs`
    Parameters:
      `value` - the id
    Returns:
      the current element builder

  - ### $class

    public Hamlet.Q<T> $class(String value)
    Description copied from interface: `HamletSpec.CoreAttrs`
    space-separated list of classes
    Specified by:
      `$class` in interface `HamletSpec.CoreAttrs`
    Parameters:
      `value` - the classes
    Returns:
      the current element builder

  - ### $title

    public Hamlet.Q<T> $title(String value)
    Description copied from interface: `HamletSpec.CoreAttrs`
    advisory title
    Specified by:
      `$title` in interface `HamletSpec.CoreAttrs`
    Parameters:
      `value` - the title
    Returns:
      the current element builder

  - ### $style

    public Hamlet.Q<T> $style(String value)
    Description copied from interface: `HamletSpec.CoreAttrs`
    associated style info
    Specified by:
      `$style` in interface `HamletSpec.CoreAttrs`
    Parameters:
      `value` - the style
    Returns:
      the current element builder

  - ### $lang

    public Hamlet.Q<T> $lang(String value)
    Description copied from interface: `HamletSpec.I18nAttrs`
    language code
    Specified by:
      `$lang` in interface `HamletSpec.I18nAttrs`
    Parameters:
      `value` - the code
    Returns:
      the current element builder

  - ### $dir

    public Hamlet.Q<T> $dir(HamletSpec.Dir value)
    Description copied from interface: `HamletSpec.I18nAttrs`
    direction for weak/neutral text
    Specified by:
      `$dir` in interface `HamletSpec.I18nAttrs`
    Parameters:
      `value` - the `HamletSpec.Dir` value
    Returns:
      the current element builder

  - ### $onclick

    public Hamlet.Q<T> $onclick(String value)
    Description copied from interface: `HamletSpec.EventsAttrs`
    a pointer button was clicked
    Specified by:
      `$onclick` in interface `HamletSpec.EventsAttrs`
    Parameters:
      `value` - the script
    Returns:
      the current element builder

  - ### $ondblclick

    public Hamlet.Q<T> $ondblclick(String value)
    Description copied from interface: `HamletSpec.EventsAttrs`
    a pointer button was double clicked
    Specified by:
      `$ondblclick` in interface `HamletSpec.EventsAttrs`
    Parameters:
      `value` - the script
    Returns:
      the current element builder

  - ### $onmousedown

    public Hamlet.Q<T> $onmousedown(String value)
    Description copied from interface: `HamletSpec.EventsAttrs`
    a pointer button was pressed down
    Specified by:
      `$onmousedown` in interface `HamletSpec.EventsAttrs`
    Parameters:
      `value` - the script
    Returns:
      the current element builder

  - ### $onmouseup

    public Hamlet.Q<T> $onmouseup(String value)
    Description copied from interface: `HamletSpec.EventsAttrs`
    a pointer button was released
    Specified by:
      `$onmouseup` in interface `HamletSpec.EventsAttrs`
    Parameters:
      `value` - the script
    Returns:
      the current element builder

  - ### $onmouseover

    public Hamlet.Q<T> $onmouseover(String value)
    Description copied from interface: `HamletSpec.EventsAttrs`
    a pointer was moved onto
    Specified by:
      `$onmouseover` in interface `HamletSpec.EventsAttrs`
    Parameters:
      `value` - the script
    Returns:
      the current element builder

  - ### $onmousemove

    public Hamlet.Q<T> $onmousemove(String value)
    Description copied from interface: `HamletSpec.EventsAttrs`
    a pointer was moved within
    Specified by:
      `$onmousemove` in interface `HamletSpec.EventsAttrs`
    Parameters:
      `value` - the script
    Returns:
      the current element builder

  - ### $onmouseout

    public Hamlet.Q<T> $onmouseout(String value)
    Description copied from interface: `HamletSpec.EventsAttrs`
    a pointer was moved away
    Specified by:
      `$onmouseout` in interface `HamletSpec.EventsAttrs`
    Parameters:
      `value` - the script
    Returns:
      the current element builder

  - ### $onkeypress

    public Hamlet.Q<T> $onkeypress(String value)
    Description copied from interface: `HamletSpec.EventsAttrs`
    a key was pressed and released
    Specified by:
      `$onkeypress` in interface `HamletSpec.EventsAttrs`
    Parameters:
      `value` - the script
    Returns:
      the current element builder

  - ### $onkeydown

    public Hamlet.Q<T> $onkeydown(String value)
    Description copied from interface: `HamletSpec.EventsAttrs`
    a key was pressed down
    Specified by:
      `$onkeydown` in interface `HamletSpec.EventsAttrs`
    Parameters:
      `value` - the script
    Returns:
      the current element builder

  - ### $onkeyup

    public Hamlet.Q<T> $onkeyup(String value)
    Description copied from interface: `HamletSpec.EventsAttrs`
    a key was released
    Specified by:
      `$onkeyup` in interface `HamletSpec.EventsAttrs`
    Parameters:
      `value` - the script
    Returns:
      the current element builder

  - ### __

    public Hamlet.Q<T> __(Object... lines)
    Description copied from interface: `HamletSpec._Content`
    Content of the element
    Specified by:
      `__` in interface `HamletSpec._Content`
    Parameters:
      `lines` - of content
    Returns:
      the current element builder

  - ### _r

    public Hamlet.Q<T> _r(Object... lines)
    Description copied from interface: `HamletSpec._RawContent`
    Raw (no need to be HTML escaped) content
    Specified by:
      `_r` in interface `HamletSpec._RawContent`
    Parameters:
      `lines` - of content
    Returns:
      the current element builder

  - ### b

    public Hamlet.B<Hamlet.Q<T>> b()
    Description copied from interface: `HamletSpec._FontStyle`
    Add a new B (bold/important) element.
    Specified by:
      `b` in interface `HamletSpec._FontStyle`
    Returns:
      a new B element builder

  - ### b

    public Hamlet.Q<T> b(String cdata)
    Description copied from interface: `HamletSpec._FontStyle`
    Add a complete B (bold/important) element.
    Specified by:
      `b` in interface `HamletSpec._FontStyle`
    Parameters:
      `cdata` - the content
    Returns:
      the current element builder

  - ### b

    public Hamlet.Q<T> b(String selector, String cdata)
    Description copied from interface: `HamletSpec._FontStyle`
    Add a complete B (bold/important) element.
    Specified by:
      `b` in interface `HamletSpec._FontStyle`
    Parameters:
      `selector` - the css select (#id)?(.class)*
      `cdata` - the content
    Returns:
      the current element builder

  - ### i

    public Hamlet.I<Hamlet.Q<T>> i()
    Description copied from interface: `HamletSpec._FontStyle`
    Add an I (italic, alt voice/mood) element.
    Specified by:
      `i` in interface `HamletSpec._FontStyle`
    Returns:
      the new I element builder

  - ### i

    public Hamlet.Q<T> i(String cdata)
    Description copied from interface: `HamletSpec._FontStyle`
    Add a complete I (italic, alt voice/mood) element.
    Specified by:
      `i` in interface `HamletSpec._FontStyle`
    Parameters:
      `cdata` - the content of the element
    Returns:
      the current element builder

  - ### i

    public Hamlet.Q<T> i(String selector, String cdata)
    Description copied from interface: `HamletSpec._FontStyle`
    Add a complete I (italic, alt voice/mood) element.
    Specified by:
      `i` in interface `HamletSpec._FontStyle`
    Parameters:
      `selector` - the css selector in the form of (#id)?(.class)*
      `cdata` - the content of the element
    Returns:
      the current element builder

  - ### small

    public Hamlet.SMALL<Hamlet.Q<T>> small()
    Description copied from interface: `HamletSpec._FontSize`
    Add a SMALL (small print) element
    Specified by:
      `small` in interface `HamletSpec._FontSize`
    Returns:
      a new SMALL element builder

  - ### small

    public Hamlet.Q<T> small(String cdata)
    Description copied from interface: `HamletSpec._FontSize`
    Add a complete small (small print) element. Shortcut of: small().__(cdata).__();
    Specified by:
      `small` in interface `HamletSpec._FontSize`
    Parameters:
      `cdata` - the content of the element
    Returns:
      the current element builder

  - ### small

    public Hamlet.Q<T> small(String selector, String cdata)
    Description copied from interface: `HamletSpec._FontSize`
    Add a complete small (small print) element. Shortcut of: small().$id(id).$class(class).__(cdata).__();
    Specified by:
      `small` in interface `HamletSpec._FontSize`
    Parameters:
      `selector` - css selector in the form of (#id)?(.class)*
      `cdata` - the content of the element
    Returns:
      the current element builder

  - ### em

    public Hamlet.Q<T> em(String cdata)
    Description copied from interface: `HamletSpec.Phrase`
    Add an EM (emphasized) element.
    Specified by:
      `em` in interface `HamletSpec.Phrase`
    Parameters:
      `cdata` - the content
    Returns:
      the current element builder

  - ### em

    public Hamlet.EM<Hamlet.Q<T>> em()
    Description copied from interface: `HamletSpec.Phrase`
    Add an EM (emphasized) element.
    Specified by:
      `em` in interface `HamletSpec.Phrase`
    Returns:
      a new EM element builder

  - ### em

    public Hamlet.Q<T> em(String selector, String cdata)
    Description copied from interface: `HamletSpec.Phrase`
    Add an EM (emphasized) element.
    Specified by:
      `em` in interface `HamletSpec.Phrase`
    Parameters:
      `selector` - the css selector in the form of (#id)*(.class)*
      `cdata` - the content
    Returns:
      the current element builder

  - ### strong

    public Hamlet.STRONG<Hamlet.Q<T>> strong()
    Description copied from interface: `HamletSpec.Phrase`
    Add a STRONG (important) element.
    Specified by:
      `strong` in interface `HamletSpec.Phrase`
    Returns:
      a new STRONG element builder

  - ### strong

    public Hamlet.Q<T> strong(String cdata)
    Description copied from interface: `HamletSpec.Phrase`
    Add a complete STRONG (important) element.
    Specified by:
      `strong` in interface `HamletSpec.Phrase`
    Parameters:
      `cdata` - the content
    Returns:
      the current element builder

  - ### strong

    public Hamlet.Q<T> strong(String selector, String cdata)
    Description copied from interface: `HamletSpec.Phrase`
    Add a complete STRONG (important) element.
    Specified by:
      `strong` in interface `HamletSpec.Phrase`
    Parameters:
      `selector` - the css selector in the form of (#id)*(.class)*
      `cdata` - the content
    Returns:
      the current element builder

  - ### dfn

    public Hamlet.DFN<Hamlet.Q<T>> dfn()
    Description copied from interface: `HamletSpec.Phrase`
    Add a DFN element.
    Specified by:
      `dfn` in interface `HamletSpec.Phrase`
    Returns:
      a new DFN element builder

  - ### dfn

    public Hamlet.Q<T> dfn(String cdata)
    Description copied from interface: `HamletSpec.Phrase`
    Add a complete DFN element.
    Specified by:
      `dfn` in interface `HamletSpec.Phrase`
    Parameters:
      `cdata` - the content
    Returns:
      the current element builder

  - ### dfn

    public Hamlet.Q<T> dfn(String selector, String cdata)
    Description copied from interface: `HamletSpec.Phrase`
    Add a complete DFN element.
    Specified by:
      `dfn` in interface `HamletSpec.Phrase`
    Parameters:
      `selector` - the css selector in the form of (#id)*(.class)*
      `cdata` - the content
    Returns:
      the current element builder

  - ### code

    public Hamlet.CODE<Hamlet.Q<T>> code()
    Description copied from interface: `HamletSpec.Phrase`
    Add a CODE (code fragment) element.
    Specified by:
      `code` in interface `HamletSpec.Phrase`
    Returns:
      a new CODE element builder

  - ### code

    public Hamlet.Q<T> code(String cdata)
    Description copied from interface: `HamletSpec.Phrase`
    Add a complete CODE element.
    Specified by:
      `code` in interface `HamletSpec.Phrase`
    Parameters:
      `cdata` - the code
    Returns:
      the current element builder

  - ### code

    public Hamlet.Q<T> code(String selector, String cdata)
    Description copied from interface: `HamletSpec.Phrase`
    Add a complete CODE element.
    Specified by:
      `code` in interface `HamletSpec.Phrase`
    Parameters:
      `selector` - the css selector in the form of (#id)*(.class)*
      `cdata` - the code
    Returns:
      the current element builder

  - ### samp

    public Hamlet.Q<T> samp(String cdata)
    Description copied from interface: `HamletSpec.Phrase`
    Add a complete SAMP (sample) element.
    Specified by:
      `samp` in interface `HamletSpec.Phrase`
    Parameters:
      `cdata` - the content
    Returns:
      the current element builder

  - ### samp

    public Hamlet.SAMP<Hamlet.Q<T>> samp()
    Description copied from interface: `HamletSpec.Phrase`
    Add a SAMP (sample) element.
    Specified by:
      `samp` in interface `HamletSpec.Phrase`
    Returns:
      a new SAMP element builder

  - ### samp

    public Hamlet.Q<T> samp(String selector, String cdata)
    Description copied from interface: `HamletSpec.Phrase`
    Add a complete SAMP (sample) element.
    Specified by:
      `samp` in interface `HamletSpec.Phrase`
    Parameters:
      `selector` - the css selector in the form of (#id)*(.class)*
      `cdata` - the content
    Returns:
      the current element builder

  - ### kbd

    public Hamlet.KBD<Hamlet.Q<T>> kbd()
    Description copied from interface: `HamletSpec.Phrase`
    Add a KBD (keyboard) element.
    Specified by:
      `kbd` in interface `HamletSpec.Phrase`
    Returns:
      a new KBD element builder

  - ### kbd

    public Hamlet.Q<T> kbd(String cdata)
    Description copied from interface: `HamletSpec.Phrase`
    Add a KBD (keyboard) element.
    Specified by:
      `kbd` in interface `HamletSpec.Phrase`
    Parameters:
      `cdata` - the content
    Returns:
      the current element builder

  - ### kbd

    public Hamlet.Q<T> kbd(String selector, String cdata)
    Description copied from interface: `HamletSpec.Phrase`
    Add a KBD (keyboard) element.
    Specified by:
      `kbd` in interface `HamletSpec.Phrase`
    Parameters:
      `selector` - the css selector in the form of (#id)*(.class)*
      `cdata` - the content
    Returns:
      the current element builder

  - ### var

    public Hamlet.VAR<Hamlet.Q<T>> var()
    Description copied from interface: `HamletSpec.Phrase`
    Add a VAR (variable) element.
    Specified by:
      `var` in interface `HamletSpec.Phrase`
    Returns:
      a new VAR element builder

  - ### var

    public Hamlet.Q<T> var(String cdata)
    Description copied from interface: `HamletSpec.Phrase`
    Add a VAR (variable) element.
    Specified by:
      `var` in interface `HamletSpec.Phrase`
    Parameters:
      `cdata` - the content
    Returns:
      the current element builder

  - ### var

    public Hamlet.Q<T> var(String selector, String cdata)
    Description copied from interface: `HamletSpec.Phrase`
    Add a VAR (variable) element.
    Specified by:
      `var` in interface `HamletSpec.Phrase`
    Parameters:
      `selector` - the css selector in the form of (#id)*(.class)*
      `cdata` - the content
    Returns:
      the current element builder

  - ### cite

    public Hamlet.CITE<Hamlet.Q<T>> cite()
    Description copied from interface: `HamletSpec.Phrase`
    Add a CITE element.
    Specified by:
      `cite` in interface `HamletSpec.Phrase`
    Returns:
      a new CITE element builder

  - ### cite

    public Hamlet.Q<T> cite(String cdata)
    Description copied from interface: `HamletSpec.Phrase`
    Add a CITE element.
    Specified by:
      `cite` in interface `HamletSpec.Phrase`
    Parameters:
      `cdata` - the content
    Returns:
      the current element builder

  - ### cite

    public Hamlet.Q<T> cite(String selector, String cdata)
    Description copied from interface: `HamletSpec.Phrase`
    Add a CITE element.
    Specified by:
      `cite` in interface `HamletSpec.Phrase`
    Parameters:
      `selector` - the css selector in the form of (#id)*(.class)*
      `cdata` - the content
    Returns:
      the current element builder

  - ### abbr

    public Hamlet.ABBR<Hamlet.Q<T>> abbr()
    Description copied from interface: `HamletSpec.Phrase`
    Add an ABBR (abbreviation) element.
    Specified by:
      `abbr` in interface `HamletSpec.Phrase`
    Returns:
      a new ABBR element builder

  - ### abbr

    public Hamlet.Q<T> abbr(String cdata)
    Description copied from interface: `HamletSpec.Phrase`
    Add a ABBR (abbreviation) element.
    Specified by:
      `abbr` in interface `HamletSpec.Phrase`
    Parameters:
      `cdata` - the content
    Returns:
      the current element builder

  - ### abbr

    public Hamlet.Q<T> abbr(String selector, String cdata)
    Description copied from interface: `HamletSpec.Phrase`
    Add a ABBR (abbreviation) element.
    Specified by:
      `abbr` in interface `HamletSpec.Phrase`
    Parameters:
      `selector` - the css selector in the form of (#id)*(.class)*
      `cdata` - the content
    Returns:
      the current element builder

  - ### a

    public Hamlet.A<Hamlet.Q<T>> a()
    Description copied from interface: `HamletSpec._Anchor`
    Add a A (anchor) element.
    Specified by:
      `a` in interface `HamletSpec._Anchor`
    Returns:
      a new A element builder

  - ### a

    public Hamlet.A<Hamlet.Q<T>> a(String selector)
    Description copied from interface: `HamletSpec._Anchor`
    Add a A (anchor) element.
    Specified by:
      `a` in interface `HamletSpec._Anchor`
    Parameters:
      `selector` - the css selector in the form of (#id)*(.class)*
    Returns:
      a new A element builder

  - ### a

    public Hamlet.Q<T> a(String href, String anchorText)
    Description copied from interface: `HamletSpec._Anchor`
    Shortcut for `a().$href(href).__(anchorText).__();`
    Specified by:
      `a` in interface `HamletSpec._Anchor`
    Parameters:
      `href` - the URI
      `anchorText` - for the URI
    Returns:
      the current element builder

  - ### a

    public Hamlet.Q<T> a(String selector, String href, String anchorText)
    Description copied from interface: `HamletSpec._Anchor`
    Shortcut for `a(selector).$href(href).__(anchorText).__();`
    Specified by:
      `a` in interface `HamletSpec._Anchor`
    Parameters:
      `selector` - in the form of (#id)?(.class)*
      `href` - the URI
      `anchorText` - for the URI
    Returns:
      the current element builder

  - ### img

    public Hamlet.IMG<Hamlet.Q<T>> img()
    Description copied from interface: `HamletSpec._ImgObject`
    Add a IMG (image) element.
    Specified by:
      `img` in interface `HamletSpec._ImgObject`
    Returns:
      a new IMG element builder

  - ### img

    public Hamlet.Q<T> img(String src)
    Description copied from interface: `HamletSpec._ImgObject`
    Add a IMG (image) element.
    Specified by:
      `img` in interface `HamletSpec._ImgObject`
    Parameters:
      `src` - the source URL of the image
    Returns:
      the current element builder

  - ### object

    public Hamlet.OBJECT<Hamlet.Q<T>> object()
    Description copied from interface: `HamletSpec._Object`
    Add an object element.
    Specified by:
      `object` in interface `HamletSpec._Object`
    Returns:
      an object element builder

  - ### object

    public Hamlet.OBJECT<Hamlet.Q<T>> object(String selector)
    Description copied from interface: `HamletSpec._Object`
    Add an object element.
    Specified by:
      `object` in interface `HamletSpec._Object`
    Parameters:
      `selector` - as #id.class etc.
    Returns:
      an object element builder

  - ### sub

    public Hamlet.SUB<Hamlet.Q<T>> sub()
    Description copied from interface: `HamletSpec._SubSup`
    Add a SUB (subscript) element.
    Specified by:
      `sub` in interface `HamletSpec._SubSup`
    Returns:
      a new SUB element builder

  - ### sub

    public Hamlet.Q<T> sub(String cdata)
    Description copied from interface: `HamletSpec._SubSup`
    Add a complete SUB (subscript) element.
    Specified by:
      `sub` in interface `HamletSpec._SubSup`
    Parameters:
      `cdata` - the content
    Returns:
      the current element builder

  - ### sub

    public Hamlet.Q<T> sub(String selector, String cdata)
    Description copied from interface: `HamletSpec._SubSup`
    Add a complete SUB (subscript) element.
    Specified by:
      `sub` in interface `HamletSpec._SubSup`
    Parameters:
      `selector` - the css selector in the form of (#id)*(.class)*
      `cdata` - the content
    Returns:
      the current element builder

  - ### sup

    public Hamlet.SUP<Hamlet.Q<T>> sup()
    Description copied from interface: `HamletSpec._SubSup`
    Add a SUP (superscript) element.
    Specified by:
      `sup` in interface `HamletSpec._SubSup`
    Returns:
      a new SUP element builder

  - ### sup

    public Hamlet.Q<T> sup(String cdata)
    Description copied from interface: `HamletSpec._SubSup`
    Add a SUP (superscript) element.
    Specified by:
      `sup` in interface `HamletSpec._SubSup`
    Parameters:
      `cdata` - the content
    Returns:
      the current element builder

  - ### sup

    public Hamlet.Q<T> sup(String selector, String cdata)
    Description copied from interface: `HamletSpec._SubSup`
    Add a SUP (superscript) element.
    Specified by:
      `sup` in interface `HamletSpec._SubSup`
    Parameters:
      `selector` - the css selector in the form of (#id)*(.class)*
      `cdata` - the content
    Returns:
      the current element builder

  - ### map

    public Hamlet.MAP<Hamlet.Q<T>> map()
    Description copied from interface: `HamletSpec._Special`
    Add a MAP element.
    Specified by:
      `map` in interface `HamletSpec._Special`
    Returns:
      a new MAP element builder

  - ### map

    public Hamlet.MAP<Hamlet.Q<T>> map(String selector)
    Description copied from interface: `HamletSpec._Special`
    Add a MAP element.
    Specified by:
      `map` in interface `HamletSpec._Special`
    Parameters:
      `selector` - the css selector in the form of (#id)*(.class)*
    Returns:
      a new MAP element builder

  - ### q

    public Hamlet.Q<T> q(String cdata)
    Description copied from interface: `HamletSpec._Special`
    Add a complete Q element.
    Specified by:
      `q` in interface `HamletSpec._Special`
    Parameters:
      `cdata` - the content
    Returns:
      the current element builder

  - ### q

    public Hamlet.Q<T> q(String selector, String cdata)
    Description copied from interface: `HamletSpec._Special`
    Add a Q element.
    Specified by:
      `q` in interface `HamletSpec._Special`
    Parameters:
      `selector` - the css selector in the form of (#id)*(.class)*
      `cdata` - the content
    Returns:
      the current element builder

  - ### q

    public Hamlet.Q<Hamlet.Q<T>> q()
    Description copied from interface: `HamletSpec._Special`
    Add a Q (inline quotation) element.
    Specified by:
      `q` in interface `HamletSpec._Special`
    Returns:
      a q (inline quotation) element builder

  - ### br

    public Hamlet.BR<Hamlet.Q<T>> br()
    Description copied from interface: `HamletSpec._Special`
    Add a BR (line break) element.
    Specified by:
      `br` in interface `HamletSpec._Special`
    Returns:
      a new BR element builder

  - ### br

    public Hamlet.Q<T> br(String selector)
    Description copied from interface: `HamletSpec._Special`
    Add a BR (line break) element.
    Specified by:
      `br` in interface `HamletSpec._Special`
    Parameters:
      `selector` - the css selector in the form of (#id)*(.class)*
    Returns:
      the current element builder

  - ### bdo

    public Hamlet.BDO<Hamlet.Q<T>> bdo()
    Description copied from interface: `HamletSpec._Special`
    Add a bdo (bidirectional override) element
    Specified by:
      `bdo` in interface `HamletSpec._Special`
    Returns:
      a bdo element builder

  - ### bdo

    public Hamlet.Q<T> bdo(HamletSpec.Dir dir, String cdata)
    Description copied from interface: `HamletSpec._Special`
    Add a bdo (bidirectional override) element
    Specified by:
      `bdo` in interface `HamletSpec._Special`
    Parameters:
      `dir` - the direction of the text
      `cdata` - the text
    Returns:
      the current element builder

  - ### span

    public Hamlet.SPAN<Hamlet.Q<T>> span()
    Description copied from interface: `HamletSpec._Special`
    Add a SPAN element.
    Specified by:
      `span` in interface `HamletSpec._Special`
    Returns:
      a new SPAN element builder

  - ### span

    public Hamlet.Q<T> span(String cdata)
    Description copied from interface: `HamletSpec._Special`
    Add a SPAN element.
    Specified by:
      `span` in interface `HamletSpec._Special`
    Parameters:
      `cdata` - the content
    Returns:
      the current element builder

  - ### span

    public Hamlet.Q<T> span(String selector, String cdata)
    Description copied from interface: `HamletSpec._Special`
    Add a SPAN element.
    Specified by:
      `span` in interface `HamletSpec._Special`
    Parameters:
      `selector` - the css selector in the form of (#id)*(.class)*
      `cdata` - the content
    Returns:
      the current element builder

  - ### script

    public Hamlet.SCRIPT<Hamlet.Q<T>> script()
    Description copied from interface: `HamletSpec._Script`
    Add a script element.
    Specified by:
      `script` in interface `HamletSpec._Script`
    Returns:
      a script element builder

  - ### script

    public Hamlet.Q<T> script(String src)
    Description copied from interface: `HamletSpec._Script`
    Add a script element
    Specified by:
      `script` in interface `HamletSpec._Script`
    Parameters:
      `src` - uri of the script
    Returns:
      the current element builder

  - ### ins

    public Hamlet.INS<Hamlet.Q<T>> ins()
    Description copied from interface: `HamletSpec._InsDel`
    Add an INS (insert) element.
    Specified by:
      `ins` in interface `HamletSpec._InsDel`
    Returns:
      an INS element builder

  - ### ins

    public Hamlet.Q<T> ins(String cdata)
    Description copied from interface: `HamletSpec._InsDel`
    Add a complete INS element.
    Specified by:
      `ins` in interface `HamletSpec._InsDel`
    Parameters:
      `cdata` - inserted data
    Returns:
      the current element builder

  - ### del

    public Hamlet.DEL<Hamlet.Q<T>> del()
    Description copied from interface: `HamletSpec._InsDel`
    Add a DEL (delete) element.
    Specified by:
      `del` in interface `HamletSpec._InsDel`
    Returns:
      a DEL element builder

  - ### del

    public Hamlet.Q<T> del(String cdata)
    Description copied from interface: `HamletSpec._InsDel`
    Add a complete DEL element.
    Specified by:
      `del` in interface `HamletSpec._InsDel`
    Parameters:
      `cdata` - deleted data
    Returns:
      the current element builder

  - ### label

    public Hamlet.LABEL<Hamlet.Q<T>> label()
    Description copied from interface: `HamletSpec._Label`
    Add a LABEL element.
    Specified by:
      `label` in interface `HamletSpec._Label`
    Returns:
      a new LABEL element builder

  - ### label

    public Hamlet.Q<T> label(String forId, String cdata)
    Description copied from interface: `HamletSpec._Label`
    Add a LABEL element. Shortcut of `label().$for(forId).__(cdata).__();`
    Specified by:
      `label` in interface `HamletSpec._Label`
    Parameters:
      `forId` - the for attribute
      `cdata` - the content
    Returns:
      the current element builder

  - ### input

    public Hamlet.INPUT<Hamlet.Q<T>> input(String selector)
    Description copied from interface: `HamletSpec._FormCtrl`
    Add a INPUT element.
    Specified by:
      `input` in interface `HamletSpec._FormCtrl`
    Parameters:
      `selector` - the css selector in the form of (#id)*(.class)*
    Returns:
      a new INPUT element builder

  - ### input

    public Hamlet.INPUT<Hamlet.Q<T>> input()
    Description copied from interface: `HamletSpec._FormCtrl`
    Add a INPUT element.
    Specified by:
      `input` in interface `HamletSpec._FormCtrl`
    Returns:
      a new INPUT element builder

  - ### select

    public Hamlet.SELECT<Hamlet.Q<T>> select()
    Description copied from interface: `HamletSpec._FormCtrl`
    Add a SELECT element.
    Specified by:
      `select` in interface `HamletSpec._FormCtrl`
    Returns:
      a new SELECT element builder

  - ### select

    public Hamlet.SELECT<Hamlet.Q<T>> select(String selector)
    Description copied from interface: `HamletSpec._FormCtrl`
    Add a SELECT element.
    Specified by:
      `select` in interface `HamletSpec._FormCtrl`
    Parameters:
      `selector` - the css selector in the form of (#id)*(.class)*
    Returns:
      a new SELECT element builder

  - ### textarea

    public Hamlet.TEXTAREA<Hamlet.Q<T>> textarea(String selector)
    Description copied from interface: `HamletSpec._FormCtrl`
    Add a TEXTAREA element.
    Specified by:
      `textarea` in interface `HamletSpec._FormCtrl`
    Parameters:
      `selector` - the css selector in the form of (#id)*(.class)*
    Returns:
      a new TEXTAREA element builder

  - ### textarea

    public Hamlet.TEXTAREA<Hamlet.Q<T>> textarea()
    Description copied from interface: `HamletSpec._FormCtrl`
    Add a TEXTAREA element.
    Specified by:
      `textarea` in interface `HamletSpec._FormCtrl`
    Returns:
      a new TEXTAREA element builder

  - ### textarea

    public Hamlet.Q<T> textarea(String selector, String cdata)
    Description copied from interface: `HamletSpec._FormCtrl`
    Add a complete TEXTAREA element.
    Specified by:
      `textarea` in interface `HamletSpec._FormCtrl`
    Parameters:
      `selector` - the css selector in the form of (#id)*(.class)*
      `cdata` - the content
    Returns:
      the current element builder

  - ### button

    public Hamlet.BUTTON<Hamlet.Q<T>> button()
    Description copied from interface: `HamletSpec._FormCtrl`
    Add a BUTTON element.
    Specified by:
      `button` in interface `HamletSpec._FormCtrl`
    Returns:
      a new BUTTON element builder

  - ### button

    public Hamlet.BUTTON<Hamlet.Q<T>> button(String selector)
    Description copied from interface: `HamletSpec._FormCtrl`
    Add a BUTTON element.
    Specified by:
      `button` in interface `HamletSpec._FormCtrl`
    Parameters:
      `selector` - the css selector in the form of (#id)*(.class)*
    Returns:
      a new BUTTON element builder

  - ### button

    public Hamlet.Q<T> button(String selector, String cdata)
    Description copied from interface: `HamletSpec._FormCtrl`
    Add a complete BUTTON element.
    Specified by:
      `button` in interface `HamletSpec._FormCtrl`
    Parameters:
      `selector` - the css selector in the form of (#id)*(.class)*
      `cdata` - the content
    Returns:
      the current element builder